//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "rtklib.h"
#include "serioptdlg.h"
#include "cmdoptdlg.h"
#include "fileoptdlg.h"
#include "tcpoptdlg.h"
#include "logstrdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLogStrDialog *LogStrDialog;
//---------------------------------------------------------------------------
__fastcall TLogStrDialog::TLogStrDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::FormShow(TObject *Sender)
{
	Stream1C ->Checked  =Stream[0]>0;
	Stream2C ->Checked  =Stream[1]>0;
	Stream1  ->ItemIndex=Stream[0]>0?Stream[0]-1:0;
	Stream2  ->ItemIndex=Stream[1]>0?Stream[1]-1:0;
	FilePath1->Text     =GetFilePath(Paths[0][2]);
	FilePath2->Text     =GetFilePath(Paths[1][2]);
	TimeTagC ->Checked  =LogTimeTag;
	AppendC  ->Checked  =LogAppend;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::BtnOkClick(TObject *Sender)
{
	Stream  [0]=Stream1C->Checked?Stream1->ItemIndex+1:0;
	Stream  [1]=Stream2C->Checked?Stream2->ItemIndex+1:0;
	Paths[0][2]=SetFilePath(FilePath1->Text);
	Paths[1][2]=SetFilePath(FilePath2->Text);
	LogTimeTag =TimeTagC->Checked;
	LogAppend  =AppendC ->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::BtnFile1Click(TObject *Sender)
{
	SaveDialog->FileName=FilePath1->Text;
	if (!SaveDialog->Execute()) return;
	FilePath1->Text=SaveDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::BtnFile2Click(TObject *Sender)
{
	SaveDialog->FileName=FilePath2->Text;
	if (!SaveDialog->Execute()) return;
	FilePath2->Text=SaveDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::Stream1Change(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::Stream2Change(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::Stream1CClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::Stream2CClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::BtnStr1Click(TObject *Sender)
{
	switch (Stream1->ItemIndex) {
		case 0: SerialOpt(2,0); break;
		case 1: TcpOpt(2,1); break;
		case 2: TcpOpt(2,0); break;
		case 3: TcpOpt(2,2); break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::BtnStr2Click(TObject *Sender)
{
	switch (Stream2->ItemIndex) {
		case 0: SerialOpt(3,0); break;
		case 1: TcpOpt(3,1); break;
		case 2: TcpOpt(3,0); break;
		case 3: TcpOpt(3,2); break;
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TLogStrDialog::GetFilePath(AnsiString path)
{
	char *p,*q,buff[1024];
	strcpy(buff,path.c_str());
	if ((p=strstr(buff,"::"))) *p='\0';
	return (path=buff);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TLogStrDialog::SetFilePath(AnsiString path)
{
	if (TimeTagC->Checked) path+="::T";
	if (AppendC ->Checked) path+="::A";
	return path;
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::SerialOpt(int index, int opt)
{
	SerialOptDialog->Path=Paths[index][0];
	SerialOptDialog->Opt=opt;
	if (SerialOptDialog->ShowModal()!=mrOk) return;
	Paths[index][0]=SerialOptDialog->Path;
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::TcpOpt(int index, int opt)
{
	TcpOptDialog->Path=Paths[index][1];
	TcpOptDialog->Opt=opt;
	for (int i=0;i<10;i++) {
		TcpOptDialog->History[i]=History[i];
		TcpOptDialog->MntpHist[i]=MntpHist[i];
	}
	if (TcpOptDialog->ShowModal()!=mrOk) return;
	Paths[index][1]=TcpOptDialog->Path;
	for (int i=0;i<10;i++) {
		History[i]=TcpOptDialog->History[i];
		MntpHist[i]=TcpOptDialog->MntpHist[i];
	}
}
//---------------------------------------------------------------------------
void __fastcall TLogStrDialog::UpdateEnable(void)
{
	int ena=Stream1C->Checked&&Stream1->ItemIndex==4||
			Stream2C->Checked&&Stream2->ItemIndex==4;
	Stream1  ->Enabled=Stream1C->Checked;
	Stream2  ->Enabled=Stream2C->Checked;
	BtnStr1  ->Enabled=Stream1C->Checked&&Stream1->ItemIndex<=3;
	BtnStr2  ->Enabled=Stream2C->Checked&&Stream2->ItemIndex<=3;
	FilePath1->Enabled=Stream1C->Checked&&Stream1->ItemIndex==4;
	FilePath2->Enabled=Stream2C->Checked&&Stream2->ItemIndex==4;
	BtnFile1 ->Enabled=Stream1C->Checked&&Stream1->ItemIndex==4;
	BtnFile2 ->Enabled=Stream2C->Checked&&Stream2->ItemIndex==4;
	LabelF1 ->Enabled=ena;
	TimeTagC->Enabled=ena;
	//AppendC->Enabled=ena;
}
//---------------------------------------------------------------------------

