//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "postmain.h"
#include "postopt.h"
#include "viewer.h"
#include "refdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptDialog *OptDialog;
//---------------------------------------------------------------------------
static double str2dbl(AnsiString str)
{
	double val=0.0;
	sscanf(str.c_str(),"%lf",&val);
	return val;
}
//---------------------------------------------------------------------------
__fastcall TOptDialog::TOptDialog(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString label,s;
	int freq[]={1,2,5,7,6};
	
	Freq->Items->Clear();
	for (int i=0;i<NFREQ;i++) {
		label=label+(i>0?"+":"")+s.sprintf("L%d",freq[i]);
		Freq->Items->Add(label);
	}
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::FormShow(TObject *Sender)
{
	GetOpt();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnOkClick(TObject *Sender)
{
	SetOpt();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnLoadClick(TObject *Sender)
{
	OpenDialog->Title="Options File";
	OpenDialog->FilterIndex=0;
	if (!OpenDialog->Execute()) return;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnSaveClick(TObject *Sender)
{
	SaveDialog->Title="Options File";
	SaveDialog->FilterIndex=0;
	if (!SaveDialog->Execute()) return;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnPrecEphViewClick(TObject *Sender)
{
	if (PrecEphFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(PrecEphFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnPrecEphFileClick(TObject *Sender)
{
	OpenDialog->Title="Satellite Precise Ephemeris File";
	OpenDialog->FileName=PrecEphFile->Text;
	OpenDialog->FilterIndex=5;
	if (!OpenDialog->Execute()) return;
	PrecEphFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnStaPosViewClick(TObject *Sender)
{
	if (StaPosFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(StaPosFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnStaPosFileClick(TObject *Sender)
{
	OpenDialog->Title="Station Postion File";
	OpenDialog->FileName=StaPosFile->Text;
	OpenDialog->FilterIndex=1;
	if (!OpenDialog->Execute()) return;
	StaPosFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovPosTypeChange(TObject *Sender)
{
	TEdit *edit[]={RovPos1,RovPos2,RovPos3};
	double pos[3];
	GetPos(RovPosTypeP,edit,pos);
	SetPos(RovPosType->ItemIndex,edit,pos);
	RovPosTypeP=RovPosType->ItemIndex;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RefPosTypeChange(TObject *Sender)
{
	TEdit *edit[]={RefPos1,RefPos2,RefPos3};
	double pos[3];
	GetPos(RefPosTypeP,edit,pos);
	SetPos(RefPosType->ItemIndex,edit,pos);
	RefPosTypeP=RefPosType->ItemIndex;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnRovPosClick(TObject *Sender)
{
	TEdit *edit[]={RovPos1,RovPos2,RovPos3};
	double p[3],pos[3];
	GetPos(RovPosType->ItemIndex,edit,p);
	ecef2pos(p,pos);
	RefDialog->RovPos[0]=pos[0]*R2D;
	RefDialog->RovPos[1]=pos[1]*R2D;
	RefDialog->Pos[2]=pos[2];
	RefDialog->StaPosFile=StaPosFile->Text;
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	if (RefDialog->ShowModal()!=mrOk) return;
	pos[0]=RefDialog->Pos[0]*D2R;
	pos[1]=RefDialog->Pos[1]*D2R;
	pos[2]=RefDialog->Pos[2];
	pos2ecef(pos,p);
	SetPos(RovPosType->ItemIndex,edit,p);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnRefPosClick(TObject *Sender)
{
	TEdit *edit[]={RefPos1,RefPos2,RefPos3};
	double p[3],pos[3];
	GetPos(RefPosType->ItemIndex,edit,p);
	ecef2pos(p,pos);
	RefDialog->RovPos[0]=pos[0]*R2D;
	RefDialog->RovPos[1]=pos[1]*R2D;
	RefDialog->RovPos[2]=pos[2];
	RefDialog->StaPosFile=StaPosFile->Text;
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	if (RefDialog->ShowModal()!=mrOk) return;
	pos[0]=RefDialog->Pos[0]*D2R;
	pos[1]=RefDialog->Pos[1]*D2R;
	pos[2]=RefDialog->Pos[2];
	pos2ecef(pos,p);
	SetPos(RefPosType->ItemIndex,edit,p);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnSatPcvViewClick(TObject *Sender)
{
	if (SatPcvFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(SatPcvFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnSatPcvFileClick(TObject *Sender)
{
	OpenDialog->Title="Satellite Antenna PCV File";
	OpenDialog->FileName=SatPcvFile->Text;
	OpenDialog->FilterIndex=4;
	if (!OpenDialog->Execute()) return;
	SatPcvFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnAntPcvViewClick(TObject *Sender)
{
	if (AntPcvFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(AntPcvFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnAntPcvFileClick(TObject *Sender)
{
	OpenDialog->Title="Receiver Antenna PCV File";
	OpenDialog->FileName=AntPcvFile->Text;
	OpenDialog->FilterIndex=3;
	if (!OpenDialog->Execute()) return;
	AntPcvFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnGoogleEarthFileClick(TObject *Sender)
{
	OpenDialog->Title="Google Earth Exe File";
	OpenDialog->FileName=GoogleEarthFile->Text;
	OpenDialog->FilterIndex=2;
	if (!OpenDialog->Execute()) return;
	GoogleEarthFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::FreqChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SolFormatChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::PosModeChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SatEphemClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::AmbResChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovAntPcvClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::NetRSCorrClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SatClkCorrClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::IntpRefObsClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovPosClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RefPosClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SbasCorrClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::OutputHeightClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::GetOpt(void)
{
	TEdit *editu[]={RovPos1,RovPos2,RovPos3};
	TEdit *editr[]={RefPos1,RefPos2,RefPos3};
	AnsiString s;
	PosMode		 ->ItemIndex	=MainForm->PosMode;
	Freq		 ->ItemIndex	=MainForm->Freq>NFREQ-1?NFREQ-1:MainForm->Freq;
	Solution	 ->ItemIndex	=MainForm->Solution;
	ElMask		 ->Text			=s.sprintf("%.0f",MainForm->ElMask);
	SnrMask		 ->Text			=s.sprintf("%.0f",MainForm->SnrMask);
	DynamicModel ->ItemIndex	=MainForm->DynamicModel;
	IonoEst		 ->ItemIndex	=MainForm->IonoEst;
	TropEst		 ->ItemIndex	=MainForm->TropEst;
	SatEphem	 ->ItemIndex	=MainForm->SatEphem;
	ExSats	     ->Text			=MainForm->ExSats;
	
	AmbRes		 ->ItemIndex	=MainForm->AmbRes;
	ValidThresAR ->Text			=s.sprintf("%.1f",MainForm->ValidThresAR);
	OutCntResetBias->Text		=s.sprintf("%d",MainForm->OutCntResetBias);
	LockCntFixAmb  ->Text		=s.sprintf("%d",MainForm->LockCntFixAmb);
	ElMaskAR	 ->Text			=s.sprintf("%.0f",MainForm->ElMaskAR);
	MaxAgeDiff	 ->Text			=s.sprintf("%.1f",MainForm->MaxAgeDiff);
	RejectThres  ->Text			=s.sprintf("%.1f",MainForm->RejectThres);
	SlipThres	 ->Text			=s.sprintf("%.3f",MainForm->SlipThres);
	NumIter		 ->Text			=s.sprintf("%d",  MainForm->NumIter);
	CodeSmooth	 ->Text			=s.sprintf("%d",  MainForm->CodeSmooth);
	
	SolFormat	 ->ItemIndex	=MainForm->SolFormat;
	TimeFormat	 ->ItemIndex	=MainForm->TimeFormat;
	LatLonFormat ->ItemIndex	=MainForm->LatLonFormat;
	FieldSep	 ->Text			=MainForm->FieldSep;
	OutputHead	 ->ItemIndex	=MainForm->OutputHead;
	OutputOpt	 ->ItemIndex	=MainForm->OutputOpt;
	OutputDatum  ->ItemIndex	=MainForm->OutputDatum;
	OutputHeight ->ItemIndex	=MainForm->OutputHeight;
	OutputGeoid  ->ItemIndex	=MainForm->OutputGeoid;
	DebugTrace	 ->ItemIndex	=MainForm->DebugTrace;
	
	MeasErr1	 ->Text			=s.sprintf("%.1f",MainForm->MeasErr1);
	MeasErr2	 ->Text			=s.sprintf("%.3f",MainForm->MeasErr2);
	MeasErr3	 ->Text			=s.sprintf("%.3f",MainForm->MeasErr3);
	MeasErr4	 ->Text			=s.sprintf("%.3f",MainForm->MeasErr4);
	SatClkStab	 ->Text			=s.sprintf("%.2E",MainForm->SatClkStab);
	PrNoise1	 ->Text			=s.sprintf("%.2E",MainForm->PrNoise1);
	PrNoise2	 ->Text			=s.sprintf("%.2E",MainForm->PrNoise2);
	PrNoise3	 ->Text			=s.sprintf("%.2E",MainForm->PrNoise3);
	
	RovAntPcv	 ->Checked		=MainForm->RovAntPcv;
	RefAntPcv	 ->Checked		=MainForm->RefAntPcv;
	RovAnt		 ->Text			=MainForm->RovAnt;
	RefAnt		 ->Text			=MainForm->RefAnt;
	RovAntE		 ->Text			=s.sprintf("%.3f",MainForm->RovAntE);
	RovAntN		 ->Text			=s.sprintf("%.3f",MainForm->RovAntN);
	RovAntU		 ->Text			=s.sprintf("%.3f",MainForm->RovAntU);
	RefAntE		 ->Text			=s.sprintf("%.3f",MainForm->RefAntE);
	RefAntN		 ->Text			=s.sprintf("%.3f",MainForm->RefAntN);
	RefAntU		 ->Text			=s.sprintf("%.3f",MainForm->RefAntU);
	AntPcvFile	 ->Text			=MainForm->AntPcvFile;
	
	IntpRefObs	 ->Checked		=MainForm->IntpRefObs;
	PrecEphFile  ->Text			=MainForm->PrecEphFile;
	SatPcvFile   ->Text			=MainForm->SatPcvFile;
	StaPosFile	 ->Text			=MainForm->StaPosFile;
	GoogleEarthFile->Text		=MainForm->GoogleEarthFile;
	RovPosType	 ->ItemIndex	=MainForm->RovPosType;
	RefPosType	 ->ItemIndex	=MainForm->RefPosType;
	RovPosTypeP					=RovPosType->ItemIndex;
	RefPosTypeP					=RefPosType->ItemIndex;
	SetPos(RovPosType->ItemIndex,editu,MainForm->RovPos);
	SetPos(RefPosType->ItemIndex,editr,MainForm->RefPos);
	ReadAntList();
	
	RovList		 ->Text			=MainForm->RovList;
	BaseList	 ->Text			=MainForm->BaseList;
	
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SetOpt(void)
{
	TEdit *editu[]={RovPos1,RovPos2,RovPos3};
	TEdit *editr[]={RefPos1,RefPos2,RefPos3};
	
	MainForm->PosMode		=PosMode	->ItemIndex;
	MainForm->Freq			=Freq		->ItemIndex;
	MainForm->Solution		=Solution   ->ItemIndex;
	MainForm->ElMask		=str2dbl(ElMask	->Text);
	MainForm->SnrMask		=str2dbl(SnrMask->Text);
	MainForm->DynamicModel	=DynamicModel->ItemIndex;
	MainForm->IonoEst	  	=IonoEst	->ItemIndex;
	MainForm->TropEst	  	=TropEst	->ItemIndex;
	MainForm->SatEphem	  	=SatEphem	->ItemIndex;
	MainForm->ExSats	  	=ExSats		->Text;
	
	MainForm->AmbRes	  	=AmbRes		->ItemIndex;
	MainForm->ValidThresAR	=str2dbl(ValidThresAR->Text);
	MainForm->OutCntResetBias=OutCntResetBias->Text.ToInt();
	MainForm->LockCntFixAmb	=LockCntFixAmb->Text.ToInt();
	MainForm->ElMaskAR	  	=ElMaskAR   ->Text.ToInt();
	MainForm->MaxAgeDiff  	=str2dbl(MaxAgeDiff ->Text);
	MainForm->RejectThres 	=str2dbl(RejectThres->Text);
	MainForm->SlipThres   	=str2dbl(SlipThres  ->Text);
	MainForm->CodeSmooth  	=CodeSmooth ->Text.ToInt();
	MainForm->NumIter	  	=NumIter	  ->Text.ToInt();
	
	MainForm->SolFormat   	=SolFormat  ->ItemIndex;
	MainForm->TimeFormat  	=TimeFormat ->ItemIndex;
	MainForm->LatLonFormat	=LatLonFormat->ItemIndex;
	MainForm->FieldSep	  	=FieldSep   ->Text;
	MainForm->OutputHead  	=OutputHead ->ItemIndex;
	MainForm->OutputOpt   	=OutputOpt  ->ItemIndex;
	MainForm->OutputDatum 	=OutputDatum->ItemIndex;
	MainForm->OutputHeight	=OutputHeight->ItemIndex;
	MainForm->OutputGeoid 	=OutputGeoid->ItemIndex;
	MainForm->DebugTrace  	=DebugTrace ->ItemIndex;
	
	MainForm->MeasErr1	  =str2dbl(MeasErr1   ->Text);
	MainForm->MeasErr2	  =str2dbl(MeasErr2   ->Text);
	MainForm->MeasErr3	  =str2dbl(MeasErr3   ->Text);
	MainForm->MeasErr4	  =str2dbl(MeasErr4   ->Text);
	MainForm->SatClkStab  =str2dbl(SatClkStab ->Text);
	MainForm->PrNoise1	  =str2dbl(PrNoise1   ->Text);
	MainForm->PrNoise2	  =str2dbl(PrNoise2   ->Text);
	MainForm->PrNoise3	  =str2dbl(PrNoise3   ->Text);
	
	MainForm->RovAntPcv   =RovAntPcv	->Checked;
	MainForm->RefAntPcv   =RefAntPcv	->Checked;
	MainForm->RovAnt	  =RovAnt		->Text;
	MainForm->RefAnt	  =RefAnt		->Text;
	MainForm->RovAntE	  =str2dbl(RovAntE	->Text);
	MainForm->RovAntN	  =str2dbl(RovAntN	->Text);
	MainForm->RovAntU	  =str2dbl(RovAntU	->Text);
	MainForm->RefAntE	  =str2dbl(RefAntE	->Text);
	MainForm->RefAntN	  =str2dbl(RefAntN	->Text);
	MainForm->RefAntU	  =str2dbl(RefAntU	->Text);
	
	MainForm->IntpRefObs  =IntpRefObs	->Checked;
	MainForm->AntPcvFile  =AntPcvFile	->Text;
	MainForm->PrecEphFile =PrecEphFile	->Text;
	MainForm->SatPcvFile  =SatPcvFile	->Text;
	MainForm->StaPosFile  =StaPosFile	->Text;
	MainForm->GoogleEarthFile=GoogleEarthFile->Text;
	MainForm->RovPosType  =RovPosType	->ItemIndex;
	MainForm->RefPosType  =RefPosType	->ItemIndex;
	GetPos(RovPosType->ItemIndex,editu,MainForm->RovPos);
	GetPos(RefPosType->ItemIndex,editr,MainForm->RefPos);
	
	MainForm->RovList	  =RovList		->Text;
	MainForm->BaseList	  =BaseList		->Text;
	
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::UpdateEnable(void)
{
	Freq->Enabled=PosMode->ItemIndex>=1;
	Solution->Enabled=PosMode->ItemIndex>=1;
	MaxAgeDiff->Enabled=PosMode->ItemIndex>=1;
	RejectThres->Enabled=PosMode->ItemIndex>=1;
	//DynamicModel->Enabled=PosMode->ItemIndex>=1&&PosMode->ItemIndex<=2;
	IonoEst->Enabled=PosMode->ItemIndex>=1&&Freq->ItemIndex>=1;
	TropEst->Enabled=PosMode->ItemIndex>=1;
	RovAnt->Enabled=RovAntPcv->Checked;
	RovAntE->Enabled=RovAntPcv->Checked;
	RovAntN->Enabled=RovAntPcv->Checked;
	RovAntU->Enabled=RovAntPcv->Checked;
	RefAnt->Enabled=RefAntPcv->Checked;
	RefAntE->Enabled=RefAntPcv->Checked;
	RefAntN->Enabled=RefAntPcv->Checked;
	RefAntU->Enabled=RefAntPcv->Checked;
	AmbRes->Enabled=PosMode->ItemIndex>=2;
	ValidThresAR->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	LockCntFixAmb->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	ElMaskAR->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	OutCntResetBias->Enabled=PosMode->ItemIndex>=2;
	SlipThres->Enabled=PosMode->ItemIndex>=2;
	NumIter->Enabled=PosMode->ItemIndex>=1;
	TimeFormat->Enabled=SolFormat->ItemIndex!=3;
	LatLonFormat->Enabled=SolFormat->ItemIndex==0;
	FieldSep->Enabled=SolFormat->ItemIndex!=3;
	OutputHead->Enabled=SolFormat->ItemIndex!=3;
	OutputOpt->Enabled=SolFormat->ItemIndex!=3;
	OutputDatum->Enabled=SolFormat->ItemIndex==0;
	OutputHeight->Enabled=SolFormat->ItemIndex==0;
	OutputGeoid->Enabled=SolFormat->ItemIndex==0&&OutputHeight->ItemIndex==1;
	//SatClkCorr->Enabled=IntpRefObs->Checked;
	//LabelSatClkCorr->Enabled=IntpRefObs->Checked&&SatClkCorr->Checked;
	//SatClkCorrFile->Enabled=IntpRefObs->Checked&&SatClkCorr->Checked;
	//BtnSatClkCorrFile->Enabled=IntpRefObs->Checked&&SatClkCorr->Checked;
	//LabelNetRSCorr->Enabled=NetRSCorr->Checked;
	//NetRSCorrFile1->Enabled=NetRSCorr->Checked;
	//NetRSCorrFile2->Enabled=NetRSCorr->Checked;
	//BtnNetRSCorrFile1->Enabled=NetRSCorr->Checked;
	//BtnNetRSCorrFile2->Enabled=NetRSCorr->Checked;
	//SbasCorr1->Enabled=SbasCorr->Checked;
	//SbasCorr2->Enabled=SbasCorr->Checked;
	//SbasCorr3->Enabled=SbasCorr->Checked;
	//SbasCorr4->Enabled=SbasCorr->Checked;
	//SbasCorrFile->Enabled=SbasCorr->Checked;
	//BtnSbasCorrFile->Enabled=SbasCorr->Checked;
	RovPosType->Enabled=PosMode->ItemIndex==5;
	RovPos1->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RovPos2->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RovPos3->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	BtnRovPos->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RefPosType->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex!=4;
	RefPos1->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex!=4&&RefPosType->ItemIndex<=2;
	RefPos2->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex!=4&&RefPosType->ItemIndex<=2;
	RefPos3->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex!=4&&RefPosType->ItemIndex<=2;
	BtnRefPos->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex!=4&&RefPosType->ItemIndex<=2;
	PrecEphFile->Enabled=SatEphem->ItemIndex==1;
	BtnPrecEphView->Enabled=SatEphem->ItemIndex==1;
	BtnPrecEphFile->Enabled=SatEphem->ItemIndex==1;
	SatPcvFile->Enabled=SatEphem->ItemIndex==1;
	BtnSatPcvView->Enabled=SatEphem->ItemIndex==1;
	BtnSatPcvFile->Enabled=SatEphem->ItemIndex==1;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::GetPos(int type, TEdit **edit, double *pos)
{
	double p[3]={0},dms1[3]={0},dms2[3]={0};
	
	if (type==1) { /* lat/lon/height dms/m */
		sscanf(edit[0]->Text.c_str(),"%lf %lf %lf",dms1,dms1+1,dms1+2);
		sscanf(edit[1]->Text.c_str(),"%lf %lf %lf",dms2,dms2+1,dms2+2);
		p[0]=(dms1[0]<0?-1:1)*(fabs(dms1[0])+dms1[1]/60+dms1[2]/3600)*D2R;
		p[1]=(dms1[0]<0?-1:1)*(fabs(dms2[0])+dms2[1]/60+dms2[2]/3600)*D2R;
		p[2]=str2dbl(edit[2]->Text);
		pos2ecef(p,pos);
	}
	else if (type==2) { /* x/y/z-ecef */
		pos[0]=str2dbl(edit[0]->Text);
		pos[1]=str2dbl(edit[1]->Text);
		pos[2]=str2dbl(edit[2]->Text);
	}
	else {
		p[0]=str2dbl(edit[0]->Text)*D2R;
		p[1]=str2dbl(edit[1]->Text)*D2R;
		p[2]=str2dbl(edit[2]->Text);
		pos2ecef(p,pos);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SetPos(int type, TEdit **edit, double *pos)
{
	AnsiString s;
	double p[3],dms1[3],dms2[3],s1,s2;
	
	if (type==1) { /* lat/lon/height dms/m */
		ecef2pos(pos,p); s1=p[0]<0?-1:1; s2=p[1]<0?-1:1;
		p[0]=fabs(p[0])*R2D+1E-12; p[1]=fabs(p[1])*R2D+1E-12;
		dms1[0]=floor(p[0]); p[0]=(p[0]-dms1[0])*60.0;
		dms1[1]=floor(p[0]); dms1[2]=(p[0]-dms1[1])*60.0;
		dms2[0]=floor(p[1]); p[1]=(p[1]-dms2[0])*60.0;
		dms2[1]=floor(p[1]); dms2[2]=(p[1]-dms2[1])*60.0;
		edit[0]->Text=s.sprintf("%.0f %02.0f %09.6f",s1*dms1[0],dms1[1],dms1[2]);
		edit[1]->Text=s.sprintf("%.0f %02.0f %09.6f",s2*dms2[0],dms2[1],dms2[2]);
		edit[2]->Text=s.sprintf("%.4f",p[2]);
	}
	else if (type==2) { /* x/y/z-ecef */
		edit[0]->Text=s.sprintf("%.4f",pos[0]);
		edit[1]->Text=s.sprintf("%.4f",pos[1]);
		edit[2]->Text=s.sprintf("%.4f",pos[2]);
	}
	else {
		ecef2pos(pos,p);
		edit[0]->Text=s.sprintf("%.9f",p[0]*R2D);
		edit[1]->Text=s.sprintf("%.9f",p[1]*R2D);
		edit[2]->Text=s.sprintf("%.4f",p[2]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::ReadAntList(void)
{
	FILE *fp;
	char buff[256]="",ant[256]="",*p,*q,*p0=buff,*p1=buff+40;
	char *tag[]={"ANTENNA ID","MODEL #"};
	TStringList *list=new TStringList;
	int i,n=0;
	list->Add("");
	if (!(fp=fopen(AntPcvFile->Text.c_str(),"r"))) return;
	while (fgets(buff,sizeof(buff),fp)) {
		if (++n==3) {
			for (i=0;i<2;i++) {
				if (!(p=strstr(buff,tag[i]))) continue;
				p0=p; for (p1=p0+strlen(tag[i]);*p1&&*p1==' ';p1++) ;
				p1-=2;
			}
		}
		if (n<12||*buff=='\0'||*buff==' ') continue;
		*p1='\0';
		for (p=p1-1;p0<=p&&*p==' ';p--) *p='\0';
		if (strcmp(p0,ant)) {list->Add(p0); strcpy(ant,p0);}
	}
	fclose(fp);
	RovAnt->Items=list;
	RefAnt->Items=list;
}

//---------------------------------------------------------------------------


